Index: dev/drm2/i915/intel_hdmi.c
===================================================================
diff --git a/head/sys/dev/drm2/i915/intel_hdmi.c b/head/sys/dev/drm2/i915/intel_hdmi.c
--- a/head/sys/dev/drm2/i915/intel_hdmi.c	(revision 276659)
+++ b/head/sys/dev/drm2/i915/intel_hdmi.c	(working copy)
@@ -37,19 +37,7 @@
 #include <dev/drm2/i915/i915_drv.h>
 #include <dev/drm2/i915/intel_drv.h>
 
-struct intel_hdmi {
-	struct intel_encoder base;
-	u32 sdvox_reg;
-	int ddc_bus;
-	uint32_t color_range;
-	bool has_hdmi_sink;
-	bool has_audio;
-	enum hdmi_force_audio force_audio;
-	void (*write_infoframe)(struct drm_encoder *encoder,
-				struct dip_infoframe *frame);
-};
-
-static struct intel_hdmi *enc_to_intel_hdmi(struct drm_encoder *encoder)
+struct intel_hdmi *enc_to_intel_hdmi(struct drm_encoder *encoder)
 {
 	return container_of(encoder, struct intel_hdmi, base.base);
 }
@@ -75,68 +63,83 @@
 	frame->checksum = 0x100 - sum;
 }
 
-static u32 intel_infoframe_index(struct dip_infoframe *frame)
+static u32 g4x_infoframe_index(struct dip_infoframe *frame)
 {
-	u32 flags = 0;
+	switch (frame->type) {
+	case DIP_TYPE_AVI:
+		return VIDEO_DIP_SELECT_AVI;
+	case DIP_TYPE_SPD:
+		return VIDEO_DIP_SELECT_SPD;
+	default:
+		DRM_DEBUG_DRIVER("unknown info frame type %d\n", frame->type);
+		return 0;
+	}
+}
 
+static u32 g4x_infoframe_enable(struct dip_infoframe *frame)
+{
 	switch (frame->type) {
 	case DIP_TYPE_AVI:
-		flags |= VIDEO_DIP_SELECT_AVI;
-		break;
+		return VIDEO_DIP_ENABLE_AVI;
 	case DIP_TYPE_SPD:
-		flags |= VIDEO_DIP_SELECT_SPD;
-		break;
+		return VIDEO_DIP_ENABLE_SPD;
 	default:
-		DRM_DEBUG("unknown info frame type %d\n", frame->type);
-		break;
+		DRM_DEBUG_DRIVER("unknown info frame type %d\n", frame->type);
+		return 0;
 	}
+}
 
-	return flags;
+static u32 hsw_infoframe_enable(struct dip_infoframe *frame)
+{
+	switch (frame->type) {
+	case DIP_TYPE_AVI:
+		return VIDEO_DIP_ENABLE_AVI_HSW;
+	case DIP_TYPE_SPD:
+		return VIDEO_DIP_ENABLE_SPD_HSW;
+	default:
+		DRM_DEBUG_DRIVER("unknown info frame type %d\n", frame->type);
+		return 0;
+	}
 }
 
-static u32 intel_infoframe_flags(struct dip_infoframe *frame)
+static u32 hsw_infoframe_data_reg(struct dip_infoframe *frame, enum pipe pipe)
 {
-	u32 flags = 0;
-
 	switch (frame->type) {
 	case DIP_TYPE_AVI:
-		flags |= VIDEO_DIP_ENABLE_AVI | VIDEO_DIP_FREQ_VSYNC;
-		break;
+		return HSW_TVIDEO_DIP_AVI_DATA(pipe);
 	case DIP_TYPE_SPD:
-		flags |= VIDEO_DIP_ENABLE_SPD | VIDEO_DIP_FREQ_VSYNC;
-		break;
+		return HSW_TVIDEO_DIP_SPD_DATA(pipe);
 	default:
-		DRM_DEBUG("unknown info frame type %d\n", frame->type);
-		break;
+		DRM_DEBUG_DRIVER("unknown info frame type %d\n", frame->type);
+		return 0;
 	}
-
-	return flags;
 }
 
-static void i9xx_write_infoframe(struct drm_encoder *encoder,
-				 struct dip_infoframe *frame)
+static void g4x_write_infoframe(struct drm_encoder *encoder,
+				struct dip_infoframe *frame)
 {
 	uint32_t *data = (uint32_t *)frame;
 	struct drm_device *dev = encoder->dev;
 	struct drm_i915_private *dev_priv = dev->dev_private;
 	struct intel_hdmi *intel_hdmi = enc_to_intel_hdmi(encoder);
-	u32 port, flags, val = I915_READ(VIDEO_DIP_CTL);
+	u32 val = I915_READ(VIDEO_DIP_CTL);
 	unsigned i, len = DIP_HEADER_SIZE + frame->len;
 
-
-	/* XXX first guess at handling video port, is this corrent? */
+	val &= ~VIDEO_DIP_PORT_MASK;
 	if (intel_hdmi->sdvox_reg == SDVOB)
-		port = VIDEO_DIP_PORT_B;
+		val |= VIDEO_DIP_PORT_B;
 	else if (intel_hdmi->sdvox_reg == SDVOC)
-		port = VIDEO_DIP_PORT_C;
+		val |= VIDEO_DIP_PORT_C;
 	else
 		return;
 
-	flags = intel_infoframe_index(frame);
+	val &= ~(VIDEO_DIP_SELECT_MASK | 0xf); /* clear DIP data offset */
+	val |= g4x_infoframe_index(frame);
 
-	val &= ~VIDEO_DIP_SELECT_MASK;
+	val &= ~g4x_infoframe_enable(frame);
+	val |= VIDEO_DIP_ENABLE;
 
-	I915_WRITE(VIDEO_DIP_CTL, VIDEO_DIP_ENABLE | val | port | flags);
+	I915_WRITE(VIDEO_DIP_CTL, val);
 
 	for (i = 0; i < len; i += 4) {
 		I915_WRITE(VIDEO_DIP_DATA, *data);
@@ -143,41 +146,163 @@
 		data++;
 	}
 
-	flags |= intel_infoframe_flags(frame);
+	val |= g4x_infoframe_enable(frame);
+	val &= ~VIDEO_DIP_FREQ_MASK;
+	val |= VIDEO_DIP_FREQ_VSYNC;
 
-	I915_WRITE(VIDEO_DIP_CTL, VIDEO_DIP_ENABLE | val | port | flags);
+	I915_WRITE(VIDEO_DIP_CTL, val);
 }
 
-static void ironlake_write_infoframe(struct drm_encoder *encoder,
-				     struct dip_infoframe *frame)
+static void ibx_write_infoframe(struct drm_encoder *encoder,
+				struct dip_infoframe *frame)
 {
 	uint32_t *data = (uint32_t *)frame;
 	struct drm_device *dev = encoder->dev;
 	struct drm_i915_private *dev_priv = dev->dev_private;
-	struct drm_crtc *crtc = encoder->crtc;
-	struct intel_crtc *intel_crtc = to_intel_crtc(crtc);
+	struct intel_crtc *intel_crtc = to_intel_crtc(encoder->crtc);
+	struct intel_hdmi *intel_hdmi = enc_to_intel_hdmi(encoder);
 	int reg = TVIDEO_DIP_CTL(intel_crtc->pipe);
 	unsigned i, len = DIP_HEADER_SIZE + frame->len;
-	u32 flags, val = I915_READ(reg);
+	u32 val = I915_READ(reg);
 
+	val &= ~VIDEO_DIP_PORT_MASK;
+	switch (intel_hdmi->sdvox_reg) {
+	case HDMIB:
+		val |= VIDEO_DIP_PORT_B;
+		break;
+	case HDMIC:
+		val |= VIDEO_DIP_PORT_C;
+		break;
+	case HDMID:
+		val |= VIDEO_DIP_PORT_D;
+		break;
+	default:
+		return;
+	}
+
 	intel_wait_for_vblank(dev, intel_crtc->pipe);
 
-	flags = intel_infoframe_index(frame);
+	val &= ~(VIDEO_DIP_SELECT_MASK | 0xf); /* clear DIP data offset */
+	val |= g4x_infoframe_index(frame);
 
+	val &= ~g4x_infoframe_enable(frame);
+	val |= VIDEO_DIP_ENABLE;
+
+	I915_WRITE(reg, val);
+
+	for (i = 0; i < len; i += 4) {
+		I915_WRITE(TVIDEO_DIP_DATA(intel_crtc->pipe), *data);
+		data++;
+	}
+
+	val |= g4x_infoframe_enable(frame);
+	val &= ~VIDEO_DIP_FREQ_MASK;
+	val |= VIDEO_DIP_FREQ_VSYNC;
+
+	I915_WRITE(reg, val);
+}
+
+static void cpt_write_infoframe(struct drm_encoder *encoder,
+				struct dip_infoframe *frame)
+{
+	uint32_t *data = (uint32_t *)frame;
+	struct drm_device *dev = encoder->dev;
+	struct drm_i915_private *dev_priv = dev->dev_private;
+	struct intel_crtc *intel_crtc = to_intel_crtc(encoder->crtc);
+	int reg = TVIDEO_DIP_CTL(intel_crtc->pipe);
+	unsigned i, len = DIP_HEADER_SIZE + frame->len;
+	u32 val = I915_READ(reg);
+
+	intel_wait_for_vblank(dev, intel_crtc->pipe);
+
 	val &= ~(VIDEO_DIP_SELECT_MASK | 0xf); /* clear DIP data offset */
+	val |= g4x_infoframe_index(frame);
 
-	I915_WRITE(reg, VIDEO_DIP_ENABLE | val | flags);
+	/* The DIP control register spec says that we need to update the AVI
+	 * infoframe without clearing its enable bit */
+	if (frame->type == DIP_TYPE_AVI)
+		val |= VIDEO_DIP_ENABLE_AVI;
+	else
+		val &= ~g4x_infoframe_enable(frame);
 
+	val |= VIDEO_DIP_ENABLE;
+
+	I915_WRITE(reg, val);
+
 	for (i = 0; i < len; i += 4) {
 		I915_WRITE(TVIDEO_DIP_DATA(intel_crtc->pipe), *data);
 		data++;
 	}
 
-	flags |= intel_infoframe_flags(frame);
+	val |= g4x_infoframe_enable(frame);
+	val &= ~VIDEO_DIP_FREQ_MASK;
+	val |= VIDEO_DIP_FREQ_VSYNC;
 
-	I915_WRITE(reg, VIDEO_DIP_ENABLE | val | flags);
+	I915_WRITE(reg, val);
 }
 
+static void vlv_write_infoframe(struct drm_encoder *encoder,
+				     struct dip_infoframe *frame)
+{
+	uint32_t *data = (uint32_t *)frame;
+	struct drm_device *dev = encoder->dev;
+	struct drm_i915_private *dev_priv = dev->dev_private;
+	struct intel_crtc *intel_crtc = to_intel_crtc(encoder->crtc);
+	int reg = VLV_TVIDEO_DIP_CTL(intel_crtc->pipe);
+	unsigned i, len = DIP_HEADER_SIZE + frame->len;
+	u32 val = I915_READ(reg);
+
+	intel_wait_for_vblank(dev, intel_crtc->pipe);
+
+	val &= ~(VIDEO_DIP_SELECT_MASK | 0xf); /* clear DIP data offset */
+	val |= g4x_infoframe_index(frame);
+
+	val &= ~g4x_infoframe_enable(frame);
+	val |= VIDEO_DIP_ENABLE;
+
+	I915_WRITE(reg, val);
+
+	for (i = 0; i < len; i += 4) {
+		I915_WRITE(VLV_TVIDEO_DIP_DATA(intel_crtc->pipe), *data);
+		data++;
+	}
+
+	val |= g4x_infoframe_enable(frame);
+	val &= ~VIDEO_DIP_FREQ_MASK;
+	val |= VIDEO_DIP_FREQ_VSYNC;
+
+	I915_WRITE(reg, val);
+}
+
+static void hsw_write_infoframe(struct drm_encoder *encoder,
+				struct dip_infoframe *frame)
+{
+	uint32_t *data = (uint32_t *)frame;
+	struct drm_device *dev = encoder->dev;
+	struct drm_i915_private *dev_priv = dev->dev_private;
+	struct intel_crtc *intel_crtc = to_intel_crtc(encoder->crtc);
+	u32 ctl_reg = HSW_TVIDEO_DIP_CTL(intel_crtc->pipe);
+	u32 data_reg = hsw_infoframe_data_reg(frame, intel_crtc->pipe);
+	unsigned int i, len = DIP_HEADER_SIZE + frame->len;
+	u32 val = I915_READ(ctl_reg);
+
+	if (data_reg == 0)
+		return;
+
+	intel_wait_for_vblank(dev, intel_crtc->pipe);
+
+	val &= ~hsw_infoframe_enable(frame);
+	I915_WRITE(ctl_reg, val);
+
+	for (i = 0; i < len; i += 4) {
+		I915_WRITE(data_reg + i, *data);
+		data++;
+	}
+
+	val |= hsw_infoframe_enable(frame);
+	I915_WRITE(ctl_reg, val);
+}
+
 static void intel_set_infoframe(struct drm_encoder *encoder,
 				struct dip_infoframe *frame)
 {
@@ -190,7 +315,8 @@
 	intel_hdmi->write_infoframe(encoder, frame);
 }
 
-static void intel_hdmi_set_avi_infoframe(struct drm_encoder *encoder)
+void intel_hdmi_set_avi_infoframe(struct drm_encoder *encoder,
+					 struct drm_display_mode *adjusted_mode)
 {
 	struct dip_infoframe avi_if = {
 		.type = DIP_TYPE_AVI,
@@ -198,10 +324,13 @@
 		.len = DIP_LEN_AVI,
 	};
 
+	if (adjusted_mode->flags & DRM_MODE_FLAG_DBLCLK)
+		avi_if.body.avi.YQ_CN_PR |= DIP_AVI_PR_2;
+
 	intel_set_infoframe(encoder, &avi_if);
 }
 
-static void intel_hdmi_set_spd_infoframe(struct drm_encoder *encoder)
+void intel_hdmi_set_spd_infoframe(struct drm_encoder *encoder)
 {
 	struct dip_infoframe spd_if;
 
@@ -222,8 +351,7 @@
 {
 	struct drm_device *dev = encoder->dev;
 	struct drm_i915_private *dev_priv = dev->dev_private;
-	struct drm_crtc *crtc = encoder->crtc;
-	struct intel_crtc *intel_crtc = to_intel_crtc(crtc);
+	struct intel_crtc *intel_crtc = to_intel_crtc(encoder->crtc);
 	struct intel_hdmi *intel_hdmi = enc_to_intel_hdmi(encoder);
 	u32 sdvox;
 
@@ -260,7 +388,7 @@
 	I915_WRITE(intel_hdmi->sdvox_reg, sdvox);
 	POSTING_READ(intel_hdmi->sdvox_reg);
 
-	intel_hdmi_set_avi_infoframe(encoder);
+	intel_hdmi_set_avi_infoframe(encoder, adjusted_mode);
 	intel_hdmi_set_spd_infoframe(encoder);
 }
 
@@ -318,7 +446,7 @@
 }
 
 static bool intel_hdmi_mode_fixup(struct drm_encoder *encoder,
-				  const struct drm_display_mode *mode,
+				  struct drm_display_mode *mode,
 				  struct drm_display_mode *adjusted_mode)
 {
 	return true;
@@ -334,7 +462,8 @@
 
 	intel_hdmi->has_hdmi_sink = false;
 	intel_hdmi->has_audio = false;
-	edid = drm_get_edid(connector, dev_priv->gmbus[intel_hdmi->ddc_bus]);
+	edid = drm_get_edid(connector, intel_gmbus_get_adapter(dev_priv,
+	    intel_hdmi->ddc_bus));
 
 	if (edid) {
 		if (edid->input & DRM_EDID_INPUT_DIGITAL) {
@@ -371,7 +500,8 @@
 	 */
 
 	return intel_ddc_get_modes(connector,
-	    dev_priv->gmbus[intel_hdmi->ddc_bus]);
+				   intel_gmbus_get_adapter(dev_priv,
+							   intel_hdmi->ddc_bus));
 }
 
 static bool
@@ -382,7 +512,9 @@
 	struct edid *edid;
 	bool has_audio = false;
 
-	edid = drm_get_edid(connector, dev_priv->gmbus[intel_hdmi->ddc_bus]);
+	edid = drm_get_edid(connector,
+			    intel_gmbus_get_adapter(dev_priv,
+						    intel_hdmi->ddc_bus));
 	if (edid) {
 		if (edid->input & DRM_EDID_INPUT_DIGITAL)
 			has_audio = drm_detect_monitor_audio(edid);
@@ -458,6 +590,14 @@
 	free(connector, DRM_MEM_KMS);
 }
 
+static const struct drm_encoder_helper_funcs intel_hdmi_helper_funcs_hsw = {
+	.dpms = intel_ddi_dpms,
+	.mode_fixup = intel_hdmi_mode_fixup,
+	.prepare = intel_encoder_prepare,
+	.mode_set = intel_ddi_mode_set,
+	.commit = intel_encoder_commit,
+};
+
 static const struct drm_encoder_helper_funcs intel_hdmi_helper_funcs = {
 	.dpms = intel_hdmi_dpms,
 	.mode_fixup = intel_hdmi_mode_fixup,
@@ -542,21 +682,59 @@
 		intel_encoder->clone_mask = (1 << INTEL_HDMIF_CLONE_BIT);
 		intel_hdmi->ddc_bus = GMBUS_PORT_DPD;
 		dev_priv->hotplug_supported_mask |= HDMID_HOTPLUG_INT_STATUS;
+	} else if (sdvox_reg == DDI_BUF_CTL(PORT_B)) {
+		DRM_DEBUG_DRIVER("LPT: detected output on DDI B\n");
+		intel_encoder->clone_mask = (1 << INTEL_HDMIB_CLONE_BIT);
+		intel_hdmi->ddc_bus = GMBUS_PORT_DPB;
+		intel_hdmi->ddi_port = PORT_B;
+		dev_priv->hotplug_supported_mask |= HDMIB_HOTPLUG_INT_STATUS;
+	} else if (sdvox_reg == DDI_BUF_CTL(PORT_C)) {
+		DRM_DEBUG_DRIVER("LPT: detected output on DDI C\n");
+		intel_encoder->clone_mask = (1 << INTEL_HDMIC_CLONE_BIT);
+		intel_hdmi->ddc_bus = GMBUS_PORT_DPC;
+		intel_hdmi->ddi_port = PORT_C;
+		dev_priv->hotplug_supported_mask |= HDMIC_HOTPLUG_INT_STATUS;
+	} else if (sdvox_reg == DDI_BUF_CTL(PORT_D)) {
+		DRM_DEBUG_DRIVER("LPT: detected output on DDI D\n");
+		intel_encoder->clone_mask = (1 << INTEL_HDMID_CLONE_BIT);
+		intel_hdmi->ddc_bus = GMBUS_PORT_DPD;
+		intel_hdmi->ddi_port = PORT_D;
+		dev_priv->hotplug_supported_mask |= HDMID_HOTPLUG_INT_STATUS;
+	} else {
+		/* If we got an unknown sdvox_reg, things are pretty much broken
+		 * in a way that we should let the kernel know about it */
+		DRM_DEBUG_KMS("unknown sdvox_reg %d\n", sdvox_reg);
 	}
 
-
 	intel_hdmi->sdvox_reg = sdvox_reg;
-
 	if (!HAS_PCH_SPLIT(dev)) {
-		intel_hdmi->write_infoframe = i9xx_write_infoframe;
+		intel_hdmi->write_infoframe = g4x_write_infoframe;
 		I915_WRITE(VIDEO_DIP_CTL, 0);
+	} else if (IS_VALLEYVIEW(dev)) {
+		intel_hdmi->write_infoframe = vlv_write_infoframe;
+		for_each_pipe(i)
+			I915_WRITE(VLV_TVIDEO_DIP_CTL(i), 0);
+	} else if (IS_HASWELL(dev)) {
+		/* FIXME: Haswell has a new set of DIP frame registers, but we are
+		 * just doing the minimal required for HDMI to work at this stage.
+		 */
+		intel_hdmi->write_infoframe = hsw_write_infoframe;
+		for_each_pipe(i)
+			I915_WRITE(HSW_TVIDEO_DIP_CTL(i), 0);
+	} else if (HAS_PCH_IBX(dev)) {
+		intel_hdmi->write_infoframe = ibx_write_infoframe;
+		for_each_pipe(i)
+			I915_WRITE(TVIDEO_DIP_CTL(i), 0);
 	} else {
-		intel_hdmi->write_infoframe = ironlake_write_infoframe;
+		intel_hdmi->write_infoframe = cpt_write_infoframe;
 		for_each_pipe(i)
 			I915_WRITE(TVIDEO_DIP_CTL(i), 0);
 	}
 
-	drm_encoder_helper_add(&intel_encoder->base, &intel_hdmi_helper_funcs);
+	if (IS_HASWELL(dev))
+		drm_encoder_helper_add(&intel_encoder->base, &intel_hdmi_helper_funcs_hsw);
+	else
+		drm_encoder_helper_add(&intel_encoder->base, &intel_hdmi_helper_funcs);
 
 	intel_hdmi_add_properties(intel_hdmi, connector);
 
Index: dev/drm2/i915/intel_iic.c
===================================================================
diff --git a/head/sys/dev/drm2/i915/intel_iic.c b/head/sys/dev/drm2/i915/intel_iic.c
--- a/head/sys/dev/drm2/i915/intel_iic.c	(revision 276659)
+++ b/head/sys/dev/drm2/i915/intel_iic.c	(working copy)
@@ -67,9 +67,22 @@
 #include "iicbus_if.h"
 #include "iicbb_if.h"
 
-static int intel_iic_quirk_xfer(device_t idev, struct iic_msg *msgs, int nmsgs);
 static void intel_teardown_gmbus_m(struct drm_device *dev, int m);
 
+struct gmbus_port {
+	const char *name;
+	int reg;
+};
+
+static const struct gmbus_port gmbus_ports[] = {
+	{ "ssc", GPIOB },
+	{ "vga", GPIOA },
+	{ "panel", GPIOC },
+	{ "dpc", GPIOD },
+	{ "dpb", GPIOE },
+	{ "dpd", GPIOF },
+};
+
 /* Intel GPIO access functions */
 
 #define I2C_RISEFALL_TIME 10
@@ -128,10 +141,7 @@
 	struct drm_i915_private *dev_priv;
 
 	dev_priv = dev->dev_private;
-	if (HAS_PCH_SPLIT(dev))
-		I915_WRITE(PCH_GMBUS0, 0);
-	else
-		I915_WRITE(GMBUS0, 0);
+	I915_WRITE(dev_priv->gpio_mmio_base + GMBUS0, 0);
 }
 
 static int
@@ -225,15 +235,134 @@
 }
 
 static int
+gmbus_xfer_read(struct drm_i915_private *dev_priv, struct iic_msg *msg,
+    u32 gmbus1_index)
+{
+	int reg_offset = dev_priv->gpio_mmio_base;
+	u16 len = msg->len;
+	u8 *buf = msg->buf;
+
+	I915_WRITE(GMBUS1 + reg_offset,
+		   gmbus1_index |
+		   GMBUS_CYCLE_WAIT |
+		   (len << GMBUS_BYTE_COUNT_SHIFT) |
+		   (msg->slave << (GMBUS_SLAVE_ADDR_SHIFT - 1)) |
+		   GMBUS_SLAVE_READ | GMBUS_SW_RDY);
+	while (len) {
+		int ret;
+		u32 val, loop = 0;
+		u32 gmbus2;
+
+		ret = _intel_wait_for(sc->drm_dev,
+		    ((gmbus2 = I915_READ(GMBUS2 + reg_offset)) &
+		    (GMBUS_SATOER | GMBUS_HW_RDY)),
+		    50, 1, "915gbr");
+		if (ret)
+			return (ETIMEDOUT);
+		if (gmbus2 & GMBUS_SATOER)
+			return (ENXIO);
+
+		val = I915_READ(GMBUS3 + reg_offset);
+		do {
+			*buf++ = val & 0xff;
+			val >>= 8;
+		} while (--len != 0 && ++loop < 4);
+	}
+
+	return 0;
+}
+
+static int
+gmbus_xfer_write(struct drm_i915_private *dev_priv, struct iic_msg *msg)
+{
+	int reg_offset = dev_priv->gpio_mmio_base;
+	u16 len = msg->len;
+	u8 *buf = msg->buf;
+	u32 val, loop;
+
+	val = loop = 0;
+	while (len && loop < 4) {
+		val |= *buf++ << (8 * loop++);
+		len -= 1;
+	}
+
+	I915_WRITE(GMBUS3 + reg_offset, val);
+	I915_WRITE(GMBUS1 + reg_offset,
+		   GMBUS_CYCLE_WAIT |
+		   (msg->len << GMBUS_BYTE_COUNT_SHIFT) |
+		   (msg->slave << (GMBUS_SLAVE_ADDR_SHIFT - 1)) |
+		   GMBUS_SLAVE_WRITE | GMBUS_SW_RDY);
+	while (len) {
+		int ret;
+		u32 gmbus2;
+
+		val = loop = 0;
+		do {
+			val |= *buf++ << (8 * loop);
+		} while (--len != 0 && ++loop < 4);
+
+		I915_WRITE(GMBUS3 + reg_offset, val);
+
+		ret = _intel_wait_for(sc->drm_dev,
+		    ((gmbus2 = I915_READ(GMBUS2 + reg_offset)) &
+		    (GMBUS_SATOER | GMBUS_HW_RDY)),
+		    50, 1, "915gbw");
+		if (ret)
+			return (ETIMEDOUT);
+		if (gmbus2 & GMBUS_SATOER)
+			return (ENXIO);
+	}
+	return 0;
+}
+
+/*
+ * The gmbus controller can combine a 1 or 2 byte write with a read that
+ * immediately follows it by using an "INDEX" cycle.
+ */
+static bool
+gmbus_is_index_read(struct iic_msg *msgs, int i, int num)
+{
+	return (i + 1 < num &&
+		!(msgs[i].flags & IIC_M_RD) && msgs[i].len <= 2 &&
+		(msgs[i + 1].flags & IIC_M_RD));
+}
+
+static int
+gmbus_xfer_index_read(struct drm_i915_private *dev_priv, struct iic_msg *msgs)
+{
+	int reg_offset = dev_priv->gpio_mmio_base;
+	u32 gmbus1_index = 0;
+	u32 gmbus5 = 0;
+	int ret;
+
+	if (msgs[0].len == 2)
+		gmbus5 = GMBUS_2BYTE_INDEX_EN |
+			 msgs[0].buf[1] | (msgs[0].buf[0] << 8);
+	if (msgs[0].len == 1)
+		gmbus1_index = GMBUS_CYCLE_INDEX |
+			       (msgs[0].buf[0] << GMBUS_SLAVE_INDEX_SHIFT);
+
+	/* GMBUS5 holds 16-bit index */
+	if (gmbus5)
+		I915_WRITE(GMBUS5 + reg_offset, gmbus5);
+
+	ret = gmbus_xfer_read(dev_priv, &msgs[1], gmbus1_index);
+
+	/* Clear GMBUS5 after each index transfer */
+	if (gmbus5)
+		I915_WRITE(GMBUS5 + reg_offset, 0);
+
+	return ret;
+}
+
+static int
 intel_gmbus_transfer(device_t idev, struct iic_msg *msgs, uint32_t nmsgs)
 {
 	struct intel_iic_softc *sc;
 	struct drm_i915_private *dev_priv;
-	u8 *buf;
-	int error, i, reg_offset, unit;
-	u32 val, loop;
-	u16 len;
+	int error, i, ret, reg_offset, unit;
 
+	error = 0;
 	sc = device_get_softc(idev);
 	dev_priv = sc->drm_dev->dev_private;
 	unit = device_get_unit(idev);
@@ -240,87 +369,47 @@
 
 	sx_xlock(&dev_priv->gmbus_sx);
 	if (sc->force_bit_dev) {
-		error = intel_iic_quirk_xfer(dev_priv->bbbus[unit], msgs, nmsgs);
+		error = IICBUS_TRANSFER(dev_priv->bbbus[unit], msgs, nmsgs);
 		goto out;
 	}
 
-	reg_offset = HAS_PCH_SPLIT(dev_priv->dev) ? PCH_GMBUS0 - GMBUS0 : 0;
+	reg_offset = dev_priv->gpio_mmio_base;
 
 	I915_WRITE(GMBUS0 + reg_offset, sc->reg0);
 
 	for (i = 0; i < nmsgs; i++) {
-		len = msgs[i].len;
-		buf = msgs[i].buf;
+		u32 gmbus2;
 
-		if ((msgs[i].flags & IIC_M_RD) != 0) {
-			I915_WRITE(GMBUS1 + reg_offset, GMBUS_CYCLE_WAIT |
-			    (i + 1 == nmsgs ? GMBUS_CYCLE_STOP : 0) |
-			    (len << GMBUS_BYTE_COUNT_SHIFT) |
-			    (msgs[i].slave << (GMBUS_SLAVE_ADDR_SHIFT - 1)) |
-			    GMBUS_SLAVE_READ | GMBUS_SW_RDY);
-			POSTING_READ(GMBUS2 + reg_offset);
-			do {
-				loop = 0;
-
-				if (_intel_wait_for(sc->drm_dev,
-				    (I915_READ(GMBUS2 + reg_offset) &
-					(GMBUS_SATOER | GMBUS_HW_RDY)) != 0,
-				    50, 1, "915gbr"))
-					goto timeout;
-				if ((I915_READ(GMBUS2 + reg_offset) &
-				    GMBUS_SATOER) != 0)
-					goto clear_err;
-
-				val = I915_READ(GMBUS3 + reg_offset);
-				do {
-					*buf++ = val & 0xff;
-					val >>= 8;
-				} while (--len != 0 && ++loop < 4);
-			} while (len != 0);
+		if (gmbus_is_index_read(msgs, i, nmsgs)) {
+			error = gmbus_xfer_index_read(dev_priv, &msgs[i]);
+			i += 1;  /* set i to the index of the read xfer */
+		} else if (msgs[i].flags & IIC_M_RD) {
+			error = gmbus_xfer_read(dev_priv, &msgs[i], 0);
 		} else {
-			val = loop = 0;
-			do {
-				val |= *buf++ << (8 * loop);
-			} while (--len != 0 && ++loop < 4);
-
-			I915_WRITE(GMBUS3 + reg_offset, val);
-			I915_WRITE(GMBUS1 + reg_offset, GMBUS_CYCLE_WAIT |
-			    (i + 1 == nmsgs ? GMBUS_CYCLE_STOP : 0) |
-			    (msgs[i].len << GMBUS_BYTE_COUNT_SHIFT) |
-			    (msgs[i].slave << (GMBUS_SLAVE_ADDR_SHIFT - 1)) |
-			    GMBUS_SLAVE_WRITE | GMBUS_SW_RDY);
-			POSTING_READ(GMBUS2+reg_offset);
-
-			while (len != 0) {
-				if (_intel_wait_for(sc->drm_dev,
-				    (I915_READ(GMBUS2 + reg_offset) &
-					(GMBUS_SATOER | GMBUS_HW_RDY)) != 0,
-				    50, 1, "915gbw"))
-					goto timeout;
-				if (I915_READ(GMBUS2 + reg_offset) & GMBUS_SATOER)
-					goto clear_err;
-
-				val = loop = 0;
-				do {
-					val |= *buf++ << (8 * loop);
-				} while (--len != 0 && ++loop < 4);
-
-				I915_WRITE(GMBUS3 + reg_offset, val);
-				POSTING_READ(GMBUS2 + reg_offset);
-			}
+			error = gmbus_xfer_write(dev_priv, &msgs[i]);
 		}
 
-		if (i + 1 < nmsgs && _intel_wait_for(sc->drm_dev,
-		    (I915_READ(GMBUS2 + reg_offset) & (GMBUS_SATOER |
-			GMBUS_HW_WAIT_PHASE)) != 0,
-		    50, 1, "915gbh"))
+		if (error == ETIMEDOUT)
 			goto timeout;
-		if ((I915_READ(GMBUS2 + reg_offset) & GMBUS_SATOER) != 0)
+		if (error == ENXIO)
 			goto clear_err;
+
+		ret = _intel_wait_for(sc->drm_dev,
+		    ((gmbus2 = I915_READ(GMBUS2 + reg_offset)) &
+		    (GMBUS_SATOER | GMBUS_HW_WAIT_PHASE)),
+		    50, 1, "915gbh");
+		if (ret)
+			goto timeout;
+		if (gmbus2 & GMBUS_SATOER)
+			goto clear_err;
 	}
 
-	error = 0;
-done:
+	/* Generate a STOP condition on the bus. Note that gmbus can't generata
+	 * a STOP on the very first cycle. To simplify the code we
+	 * unconditionally generate the STOP condition with an additional gmbus
+	 * cycle. */
+	I915_WRITE(GMBUS1 + reg_offset, GMBUS_CYCLE_STOP | GMBUS_SW_RDY);
+
 	/* Mark the GMBUS interface as disabled after waiting for idle.
 	 * We will re-enable it at the start of the next xfer,
 	 * till then let it sleep.
@@ -327,14 +416,25 @@
  	 */
 	if (_intel_wait_for(dev,
 	    (I915_READ(GMBUS2 + reg_offset) & GMBUS_ACTIVE) == 0,
-	    10, 1, "915gbu"))
-		DRM_INFO("GMBUS timed out waiting for idle\n");
+	    10, 1, "915gbu")) {
+		DRM_DEBUG_KMS("GMBUS [%s] timed out waiting for idle\n",
+		    sc->name);
+		error = ETIMEDOUT;
+	}
 	I915_WRITE(GMBUS0 + reg_offset, 0);
-out:
-	sx_xunlock(&dev_priv->gmbus_sx);
-	return (error);
+	goto out;
 
 clear_err:
+	/*
+	 * Wait for bus to IDLE before clearing NAK.
+	 * If we clear the NAK while bus is still active, then it will stay
+	 * active and the next transaction may fail.
+	 */
+	if (_intel_wait_for(dev,
+	    (I915_READ(GMBUS2 + reg_offset) & GMBUS_ACTIVE) == 0,
+	    10, 1, "915gbu"))
+		DRM_DEBUG_KMS("GMBUS [%s] timed out after NAK\n", sc->name);
+
 	/* Toggle the Software Clear Interrupt bit. This has the effect
 	 * of resetting the GMBUS controller and so clearing the
 	 * BUS_ERROR raised by the slave's NAK.
@@ -341,12 +441,25 @@
 	 */
 	I915_WRITE(GMBUS1 + reg_offset, GMBUS_SW_CLR_INT);
 	I915_WRITE(GMBUS1 + reg_offset, 0);
-	error = EIO;
-	goto done;
+	I915_WRITE(GMBUS0 + reg_offset, 0);
 
+	DRM_DEBUG_KMS("GMBUS [%s] NAK for addr: %04x %c(%d)\n",
+			 sc->name, msgs[i].slave,
+			 (msgs[i].flags & IIC_M_RD) ? 'r' : 'w', msgs[i].len);
+
+	/*
+	 * If no ACK is received during the address phase of a transaction,
+	 * the adapter must report -ENXIO.
+	 * It is not clear what to return if no ACK is received at other times.
+	 * So, we always return -ENXIO in all NAK cases, to ensure we send
+	 * it at least during the one case that is specified.
+	 */
+	error = ENXIO;
+	goto out;
+
 timeout:
-	DRM_INFO("GMBUS timed out, falling back to bit banging on pin %d [%s]\n",
-	    sc->reg0 & 0xff, sc->name);
+	DRM_INFO("GMBUS [%s] timed out, falling back to bit banging on pin %d\n",
+	    sc->name, sc->reg0 & 0xff);
 	I915_WRITE(GMBUS0 + reg_offset, 0);
 
 	/*
@@ -354,11 +467,25 @@
 	 * Try GPIO bitbanging instead.
 	 */
 	sc->force_bit_dev = true;
+	error = IICBUS_TRANSFER(idev, msgs, nmsgs);
+	goto out;
 
-	error = intel_iic_quirk_xfer(dev_priv->bbbus[unit], msgs, nmsgs);
-	goto out;
+out:
+	sx_xunlock(&dev_priv->gmbus_sx);
+	return (error);
 }
 
+device_t 
+intel_gmbus_get_adapter(struct drm_i915_private *dev_priv,
+    unsigned port)
+{
+
+	if (!intel_gmbus_is_port_valid(port))
+		DRM_ERROR("GMBUS get adapter %d: invalid port\n", port);
+	return (intel_gmbus_is_port_valid(port) ? dev_priv->gmbus[port - 1] :
+	    NULL);
+}
+
 void
 intel_gmbus_set_speed(device_t idev, int speed)
 {
@@ -379,47 +506,36 @@
 }
 
 static int
-intel_iic_quirk_xfer(device_t idev, struct iic_msg *msgs, int nmsgs)
+intel_iicbb_pre_xfer(device_t idev)
 {
-	device_t bridge_dev;
 	struct intel_iic_softc *sc;
 	struct drm_i915_private *dev_priv;
-	int ret;
-	int i;
 
-	bridge_dev = device_get_parent(device_get_parent(idev));
-	sc = device_get_softc(bridge_dev);
+	sc = device_get_softc(idev);
 	dev_priv = sc->drm_dev->dev_private;
 
 	intel_iic_reset(sc->drm_dev);
 	intel_iic_quirk_set(dev_priv, true);
-	IICBB_SETSDA(bridge_dev, 1);
-	IICBB_SETSCL(bridge_dev, 1);
+	IICBB_SETSDA(idev, 1);
+	IICBB_SETSCL(idev, 1);
 	DELAY(I2C_RISEFALL_TIME);
+	return (0);
+}
 
-	for (i = 0; i < nmsgs - 1; i++) {
-		/* force use of repeated start instead of default stop+start */
-		msgs[i].flags |= IIC_M_NOSTOP;
-	}
-	ret = iicbus_transfer(idev, msgs, nmsgs);
-	IICBB_SETSDA(bridge_dev, 1);
-	IICBB_SETSCL(bridge_dev, 1);
+static void
+intel_iicbb_post_xfer(device_t idev)
+{
+	struct intel_iic_softc *sc;
+	struct drm_i915_private *dev_priv;
+
+	sc = device_get_softc(idev);
+	dev_priv = sc->drm_dev->dev_private;
+
+	IICBB_SETSDA(idev, 1);
+	IICBB_SETSCL(idev, 1);
 	intel_iic_quirk_set(dev_priv, false);
-
-	return (ret);
 }
 
-static const char *gpio_names[GMBUS_NUM_PORTS] = {
-	"disabled",
-	"ssc",
-	"vga",
-	"panel",
-	"dpc",
-	"dpb",
-	"reserved",
-	"dpd",
-};
-
 static int
 intel_gmbus_probe(device_t dev)
 {
@@ -432,23 +548,28 @@
 {
 	struct drm_i915_private *dev_priv;
 	struct intel_iic_softc *sc;
-	int pin;
+	int pin, port;
 
 	sc = device_get_softc(idev);
 	sc->drm_dev = device_get_softc(device_get_parent(idev));
 	dev_priv = sc->drm_dev->dev_private;
 	pin = device_get_unit(idev);
+	port = pin + 1;
 
-	snprintf(sc->name, sizeof(sc->name), "gmbus bus %s", gpio_names[pin]);
+	snprintf(sc->name, sizeof(sc->name), "gmbus %s", gmbus_ports[pin].name);
 	device_set_desc(idev, sc->name);
 
 	/* By default use a conservative clock rate */
-	sc->reg0 = pin | GMBUS_RATE_100KHZ;
+	sc->reg0 = port | GMBUS_RATE_100KHZ;
 
-	/* XXX force bit banging until GMBUS is fully debugged */
+	/* gmbus seems to be broken on i830 */
+	if (IS_I830(sc->drm_dev))
+		sc->force_bit_dev = true;
+#if 0
 	if (IS_GEN2(sc->drm_dev)) {
 		sc->force_bit_dev = true;
 	}
+#endif
 
 	/* add bus interface device */
 	sc->iic_dev = device_add_child(idev, "iicbus", -1);
@@ -490,17 +611,6 @@
 static int
 intel_iicbb_attach(device_t idev)
 {
-	static const int map_pin_to_reg[] = {
-		0,
-		GPIOB,
-		GPIOA,
-		GPIOC,
-		GPIOD,
-		GPIOE,
-		0,
-		GPIOF
-	};
-
 	struct intel_iic_softc *sc;
 	struct drm_i915_private *dev_priv;
 	int pin;
@@ -510,13 +620,12 @@
 	dev_priv = sc->drm_dev->dev_private;
 	pin = device_get_unit(idev);
 
-	snprintf(sc->name, sizeof(sc->name), "i915 iicbb %s", gpio_names[pin]);
+	snprintf(sc->name, sizeof(sc->name), "i915 iicbb %s",
+	    gmbus_ports[pin].name);
 	device_set_desc(idev, sc->name);
 
 	sc->reg0 = pin | GMBUS_RATE_100KHZ;
-	sc->reg = map_pin_to_reg[pin];
-	if (HAS_PCH_SPLIT(dev_priv->dev))
-		sc->reg += PCH_GPIOA - GPIOA;
+	sc->reg = dev_priv->gpio_mmio_base + gmbus_ports[pin].reg;
 
 	/* add generic bit-banging code */
 	sc->iic_dev = device_add_child(idev, "iicbb", -1);
@@ -524,6 +633,7 @@
 		return (ENXIO);
 	device_quiet(sc->iic_dev);
 	bus_generic_attach(idev);
+	iicbus_set_nostop(idev, true);
 
 	return (0);
 }
@@ -574,6 +684,8 @@
 	DEVMETHOD(iicbb_setscl,		intel_iicbb_setscl),
 	DEVMETHOD(iicbb_getsda,		intel_iicbb_getsda),
 	DEVMETHOD(iicbb_getscl,		intel_iicbb_getscl),
+	DEVMETHOD(iicbb_pre_xfer,	intel_iicbb_pre_xfer),
+	DEVMETHOD(iicbb_post_xfer,	intel_iicbb_post_xfer),
 	DEVMETHOD_END
 };
 static driver_t intel_iicbb_driver = {
@@ -595,14 +707,10 @@
 
 	dev_priv = dev->dev_private;
 	sx_init(&dev_priv->gmbus_sx, "gmbus");
-	dev_priv->gmbus_bridge = malloc(sizeof(device_t) * GMBUS_NUM_PORTS,
-	    DRM_MEM_DRIVER, M_WAITOK | M_ZERO);
-	dev_priv->bbbus_bridge = malloc(sizeof(device_t) * GMBUS_NUM_PORTS,
-	    DRM_MEM_DRIVER, M_WAITOK | M_ZERO);
-	dev_priv->gmbus = malloc(sizeof(device_t) * GMBUS_NUM_PORTS,
-	    DRM_MEM_DRIVER, M_WAITOK | M_ZERO);
-	dev_priv->bbbus = malloc(sizeof(device_t) * GMBUS_NUM_PORTS,
-	    DRM_MEM_DRIVER, M_WAITOK | M_ZERO);
+	if (HAS_PCH_SPLIT(dev))
+		dev_priv->gpio_mmio_base = PCH_GPIOA - GPIOA;
+	else
+		dev_priv->gpio_mmio_base = 0;
 
 	/*
 	 * The Giant there is recursed, most likely.  Normally, the
@@ -610,7 +718,7 @@
 	 * driver.
 	 */
 	mtx_lock(&Giant);
-	for (i = 0; i < GMBUS_NUM_PORTS; i++) {
+	for (i = 0; i <= GMBUS_NUM_PORTS; i++) {
 		/*
 		 * Initialized bbbus_bridge before gmbus_bridge, since
 		 * gmbus may decide to force quirk transfer in the
@@ -689,14 +797,6 @@
 
 	dev_priv = dev->dev_private;
 
-	free(dev_priv->gmbus, DRM_MEM_DRIVER);
-	dev_priv->gmbus = NULL;
-	free(dev_priv->bbbus, DRM_MEM_DRIVER);
-	dev_priv->bbbus = NULL;
-	free(dev_priv->gmbus_bridge, DRM_MEM_DRIVER);
-	dev_priv->gmbus_bridge = NULL;
-	free(dev_priv->bbbus_bridge, DRM_MEM_DRIVER);
-	dev_priv->bbbus_bridge = NULL;
 	sx_destroy(&dev_priv->gmbus_sx);
 }
 
Index: dev/drm2/i915/intel_lvds.c
===================================================================
diff --git a/head/sys/dev/drm2/i915/intel_lvds.c b/head/sys/dev/drm2/i915/intel_lvds.c
--- a/head/sys/dev/drm2/i915/intel_lvds.c	(revision 276659)
+++ b/head/sys/dev/drm2/i915/intel_lvds.c	(working copy)
@@ -230,7 +230,7 @@
 }
 
 static bool intel_lvds_mode_fixup(struct drm_encoder *encoder,
-				  const struct drm_display_mode *mode,
+				  struct drm_display_mode *mode,
 				  struct drm_display_mode *adjusted_mode)
 {
 	struct drm_device *dev = encoder->dev;
@@ -482,7 +482,7 @@
 
 static int intel_no_modeset_on_lid_dmi_callback(const struct dmi_system_id *id)
 {
-	DRM_DEBUG_KMS("Skipping forced modeset for %s\n", id->ident);
+	DRM_INFO("Skipping forced modeset for %s\n", id->ident);
 	return 1;
 }
 
@@ -638,7 +638,7 @@
 
 static int intel_no_lvds_dmi_callback(const struct dmi_system_id *id)
 {
-	DRM_DEBUG_KMS("Skipping LVDS initialization for %s\n", id->ident);
+	DRM_INFO("Skipping LVDS initialization for %s\n", id->ident);
 	return 1;
 }
 
@@ -861,8 +861,8 @@
 		    child->device_type != DEVICE_TYPE_LFP)
 			continue;
 
-		if (child->i2c_pin)
-		    *i2c_pin = child->i2c_pin;
+		if (intel_gmbus_is_port_valid(child->i2c_pin))
+			*i2c_pin = child->i2c_pin;
 
 		/* However, we cannot trust the BIOS writers to populate
 		 * the VBT correctly.  Since LVDS requires additional
@@ -996,7 +996,8 @@
 	 * Attempt to get the fixed panel mode from DDC.  Assume that the
 	 * preferred mode is the right one.
 	 */
-	intel_lvds->edid = drm_get_edid(connector, dev_priv->gmbus[pin]);
+	intel_lvds->edid = drm_get_edid(connector,
+					intel_gmbus_get_adapter(dev_priv, pin));
 	if (intel_lvds->edid) {
 		if (drm_add_edid_modes(connector,
 				       intel_lvds->edid)) {
